local addon = CreateFrame("Frame", "BuyCrap")

function addon:Print(...) DEFAULT_CHAT_FRAME:AddMessage(string.join(" ", "|cFF33FF99BuyCrap|r:", ...)) end
function addon:PrintF(fmsg, ...) DEFAULT_CHAT_FRAME:AddMessage(string.format("|cFF33FF99BuyCrap|r: "..fmsg, ...)) end

addon:SetScript("OnEvent", function(self, event, ...)
	if self[event] then self[event](self, event, ...) end
end)
addon:RegisterEvent("ADDON_LOADED")

function addon:ADDON_LOADED(event, addon_name)
	if addon_name ~= "BuyCrap" then return end
	
	BuyCrapItems = BuyCrapItems or {}
	BuyCrapOptions = BuyCrapOptions or {}
	self.items = BuyCrapItems
	self.options = BuyCrapOptions
	local defaults = {overfill = false, announce = true,}
	setmetatable(BuyCrapOptions, {__index=function(t,i) if defaults[i] then return defaults[i] end end,})
	
	self:UnregisterEvent("ADDON_LOADED")
	self:RegisterEvent("MERCHANT_SHOW")
	
	if MerchantFrame:IsVisible() then self:MERCHANT_SHOW() end
end

local itemids = setmetatable({}, {__index = function(t,i)
	local id = i and tonumber(string.match(i, "item:(%d+):"))
	if not id then return 0 end
	t[i] = id
	return id
end})
function addon:MERCHANT_SHOW()
	local numItems = GetMerchantNumItems()
	for i=1, numItems, 1 do
		local link = GetMerchantItemLink(i)
		local needed = (link and self.items[itemids[link]] or 0) - GetItemCount(link)
		if needed > 0 then
			local in_stacks, num_available = select(4, GetMerchantItemInfo(i))
			local max_stack = select(8, GetItemInfo(link))
			
			if num_available > 0 and num_available < needed then needed = num_available end
			local stacks = math.floor(needed / in_stacks)
			local stacks_to_fullstack = max_stack / in_stacks
			
			if self.options.overfill and ((needed % in_stacks) > 0) then stacks = stacks + 1 end
			if self.options.announce then self:PrintF("Buying %s x%d", link, needed) end
			
			local stacks_needed = math.floor(stacks / stacks_to_fullstack)
			if stacks_needed > 0 then
				for j=0, stacks_needed, 1 do
					BuyMerchantItem(i, stacks_to_fullstack)
				end
			end
			local remainder = (stacks % stacks_to_fullstack)
			if remainder > 0 then BuyMerchantItem(i, remainder) end
		end
	end
end
